<!doctype html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>The BioMedIT Infrastructure</title>

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">
    <link rel="stylesheet" href="dist/theme/league.css" id="theme">
    <link rel="stylesheet" href="css/custom.css">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css" id="highlight-theme">
</head>
<body>
<div class="reveal">
    <div class="slides">
        <section>
            <img src="img/logo.svg" alt="Logo" class="plain"/>
            <h2>The BioMedIT Infrastructure</h2>
            <p>
                <small><a href="mailto:gerhard.braeunlich@id.ethz.ch">Gerhard Bräunlich</a> (author)</small><br>
                <small><a href="mailto:christian.ribeaud@karakun.com">Christian Ribeaud</a> (pirate/plagiarizer)</small>
            </p>
        </section>
        <section>
            <h2>BioMedIT</h2>
            <img alt="biomedit" src="img/biomedit.svg">
        </section>
        <section>
            <h3>BioMedIT Network</h3>
            <img alt="biomedit-network" src="img/biomedit-network.svg">
        </section>
        <section>
            <h3>The BIWG</h3>
            <div class="member-box">
                <h2>DCC <img class="organization" alt="SIB"
                             src="img/organization/SIB.png"></h2>
                <div class="member">
                    <img class="avatar" alt="skapoor" src="img/members/skapoor.png">
                    <div class="name">Shubham Kapoor</div>
                    <div class="function">Lead System Architect</div>
                </div>
                <div class="member">
                    <img class="avatar" alt="sguzzi" src="img/members/simone.png">
                    <div class="name">Simone Guzzi</div>
                    <div class="function">Developer</div>
                </div>
            </div>

            <div class="member-box">
                <h2>External <img class="organization" alt="Karakun"
                                  src="img/organization/karakun.png"></h2>
                <div class="member">
                    <img class="avatar" alt="cribeaud" src="img/members/cribeaud.png">
                    <div class="name">Christian Ribeaud</div>
                    <div class="function">Scrum Master</div>
                </div>
            </div>

            <div class="member-box">
                <h2>SciCore <img class="organization" alt="Uni Basel"
                                 src="img/organization/uni-basel.svg"></h2>
                <div class="member">
                    <img class="avatar" alt="jsurkont" src="img/members/jsurkont.png">
                    <div class="name">Jaroslaw Surkont</div>
                    <div class="function">Developer</div>
                </div>
            </div>

            <div class="member-box">
                <h2>Core-IT <img class="organization" alt="Uni Lausanne"
                                 src="img/organization/unil.svg"></h2>
                <div class="member">
                    <img class="avatar" alt="rengler" src="img/members/rengler.png">
                    <div class="name">Robin Engler</div>
                    <div class="function">Developer</div>
                </div>
            </div>

            <div class="member-box">
                <h2>SIS <img class="organization" alt="ETH Zürich"
                             src="img/organization/ethz.svg"></h2>
                <div class="member">
                    <img class="avatar" alt="aparker" src="img/members/althea.png">
                    <div class="name">Althea Parker</div>
                    <div class="function">Developer</div>
                </div>
                <div class="member">
                    <img class="avatar" alt="gvermeul" src="img/members/swen.png">
                    <div class="name">Swen Vermeul</div>
                    <div class="function">Developer</div>
                </div>
            </div>
        </section>

        <section>
            <h3>Services / Software</h3>
            <ul style="list-style:none">
                <li><img class="icon" src="img/portal.svg">portal (<a href="https://portal.dcc.sib.swiss">portal.dcc.sib.swiss</a>)
                </li>
                <li><img class="icon" src="img/keyserver.svg">keyserver (<a href="https://keys.openpgp.org/">keys.openpgp.org</a>)
                </li>
                <li><img class="icon" src="img/sett.svg">sett (<a href="https://gitlab.com/biomedit/sett">gitlab.com/biomedit/sett</a>)
                </li>
                <li><img class="icon" src="img/lz-white.svg">Landing Zones (LeoMed, SciCore Med, Sensa)</li>
            </ul>
        </section>
        <section>
            <h3>Secure data transfer workflow</h3>
            <img alt="services" src="img/services.svg" class="stretch">
        </section>
        <section>
            <h3>Portal</h3>
            <img class="logo" src="img/portal.svg">
            <b><a href="https://portal.dcc.sib.swiss/" target="_blank">Entry point to all BioMedIT services</a></b>
            <ul>
                <li>Login with SWITCH edu-ID account</li>
                <li>Project/user management</li>
                <li>Request data transfers / view their status</li>
                <li>View Notifications</li>
                <li>Hosting of PGP keys trust model (key approval by DCC)
                </li>
                <li>Links to the respective project spaces at nodes via
                    remote desktop / ssh
                </li>
                <li>Provide REST API used by <b>sett</b> to check for data transfer authorization</li>
            </ul>
        </section>
        <section>
            <img class="logo" src="img/portal.svg">
            <h3>Under the hood</h3>
            <ul>
                <li>Django (python) backend / React (typescript) frontend</li>
                <li>Hosted at Uni Basel</li>
            </ul>
        </section>
        <section>
            <h3>CI</h3>
            <img class="logo" src="img/portal.svg">
            <ul>
                <li>Backend</li>
                <ul>
                    <li>python test (tox)</li>
                    <li>pylint, bandit, black</li>
                </ul>
                <li>Frontend</li>
                <ul>
                    <li>typescript test (jest)</li>
                    <li>eslint</li>
                    <li>type coverage</li>
                </ul>
                <li>Build docker image</li>
                <li>Auto deploy as a docker container</li>
            </ul>
        </section>
        <section data-background-iframe="https://keys.openpgp.org/" data-background-interactive>
            <img class="logo" src="img/keyserver.svg">
            <div class="label-box">
                <h4>keys.openpgp.org</h4>
                <ul>
                    <li>Search for public keys of data recipients (people to whom you want to send data)</li>
                </ul>
            </div>
        </section>
        <section>
            <h3>SETT <small>Secure Encryption and Transfer Tool</small></h3>
            Automation around Sequoia (OpenPGP implementation), zip (tar), s3 (sftp).
            <img class="logo" src="img/sett.svg" alt="sett">
            <br/>

            Structure of a SETT bundle:
            <pre class="stretch">
            <code>
    YYYYMMDDThhmmss.zip
    ├── metadata.json
    ├── metadata.json.sig (Detached signature for `metadata.json`)
    └── data.tar.gz.gpg (compressed and encrypted data)
        └── data.tar.gz
            ├── content/
            |   ├── [file1]
            |   ├── [file2]
            |   └── ...
            └── checksum.sha256 (checksums of files in content)
            </code>
          </pre>

        </section>
        <section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="2">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>transfer_id</code>: transfer ID.
                </div>
            </section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="3">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>sender</code>: fingerprint of sender's PGP key.
                </div>
            </section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="4">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>recipients</code>: list of fingerprints of
                    recipients' public PGP keys.
                </div>
            </section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="5">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>timestamp</code>: datetime of metadata generation in the format
                    <code>YYYY-MM-DDThh:mm:ss±ZZZZ</code>
                    (where <code>ZZZZ</code> is the UTC offset)
                </div>
            </section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="6">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>checksum</code>: sha256 checksum of the encrypted `data.tar.gz.gpg` file. This allows
                    verifying the integrity of the file without decrypting it.
                </div>
            </section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="7">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>checksum_algorithm</code>: algorithm used to
                    compute the checksum. Currently sha256.
                </div>
            </section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="8">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>compression_algorithm</code>: currently only gzip
                </div>
            </section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="9">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>purpose</code>: PRODUCTION or TEST
                </div>
            </section>
            <section data-transition="none">
                <img class="logo" src="img/sett.svg" alt="sett">
                <code>metadata.json</code>
                <pre>
              <code class="json" data-noescape
                    data-trim data-line-numbers="10">
                {
                "transfer_id": 42,
                "sender": "AAABFBC698539AB6CE60BDBE8220117C2F906548",
                "recipients": ["D99AD936FC83C9BABDE7C33E1CF8C1A2076818C3"],
                "timestamp": "2020-01-29T15:31:42+0100",
                "checksum": "a8eb0ee5a6a53326b1c6f9bf94136da5d98a1dc6dceee21d62f694d71c4cf184",
                "checksum_algorithm": "SHA256",
                "compression_algorithm": "gzip",
                "purpose": "PRODUCTION",
                "version": "0.7"
                }
              </code>
            </pre>
                <div class="description">
                    <code>version</code>: the version of the metadata
                    specifications.
                </div>
            </section>

        </section>
        <section>
            <img class="logo" src="img/sett.svg" alt="sett">
            <img src="img/sett.png" alt="sett" height="600">
            <div class="label-box" style="top: 0; right: 0; left: -7vw;">
                <h3>sett</h3>
                <ul>
                    <li>Data encryption/decryption, compression, checksuming, signing</li>
                    <li>Transfer via S3, SFTP (paramiko) or LiquidFiles</li>
                    <li>PGP key management: key creation, deletion,
                        up-/download from <a href="https://keys.openpgp.org/">keyserver</a>, trust model in
                        <b>portal</b></li>
                    <li>GUI / CLI versions</li>
                    <li><a href="https://sett.readthedocs.io/">Readthedocs</a></li>
                    <li><a href="https://gitlab.com/biomedit/sett">Open Source</a></li>
                    <li>Checks validity of involved keys against
                        <a href="https://portal.dcc.sib.swiss">portal</a></li>
                    <li>Checks against <a href="https://portal.dcc.sib.swiss">portal</a> that data transfer is authorized
                        by the DCC, recipient has DM privileges for the project, ...
                    </li>
                    <li>Also usable outside BioMedIt (without connection to portal / transfer id)
                    </li>
                </ul>
            </div>
        </section>
        <section>
            <img class="logo" src="img/sett.svg" alt="sett">
            <p><b>Under the hood</b></p>
            <ul>
                <li>Written in python 🐍 and rust 🦀</li>
                <li><a href="https://gitlab.com/biomedit/sett">gitlab.com/biomedit/sett</a> / <a
                        href="https://pypi.org/project/sett">pypi.org/project/sett</a></li>
                <li>Dependencies: <a href="https://gitlab.com/biomedit/gpg-lite">gpg-lite</a>,</li>
                <a href="https://gitlab.com/biomedit/libbiomedit">libbiomedit</a> (shared code
                with landing zones)
            </ul>

            <p><b>CI</b></p>
            <ul>
                <li>Automatic <code>dev</code> release and version management</li>
                <li>Deployment to PyPI</li>
                <li>Tests (tox)</li>
                <li>Coverage</li>
                <li>pylint, black, bandit, mypy</li>
            </ul>
        </section>
        <section>
            <h3>Landing Zone automation script</h3>
            <img class="logo" src="img/lz-white.svg">

            <b>Service to route packages through the network</b>

            <img src="img/landing-zone.svg" alt="lz" class="stretch">

            <div class="label-box" style="top: 400px">
                <ul>
                    <li>Scans configured folders for uploaded files.
                        Moves them into project space or uploads them to another node.
                    </li>
                    <li>Verifies package integrity (e.g. metadata signature,
                        metadata content against portal).
                    </li>
                    <li>Reports packages to the portal (logging)</li>
                </ul>
            </div>
        </section>
        <section>
            <h3>Under the hood</h3>
            <img class="logo" src="img/lz-white.svg">
            <ul>
                <li>Written in python 🐍</li>
                <li>Run as a cron job</li>
                <li>Depends on
                    <a href="https://gitlab.com/biomedit/gpg-lite">gpg-lite</a>
                    and <a href="https://gitlab.com/biomedit/libbiomedit">libbiomedit</a> (shared code with SETT)
                </li>
            </ul>

            <h3>CI</h3>
            <ul>
                <li>Tests</li>
                <li>pylint, black, bandit, mypy</li>
                <li>Depends on
                    <a href="https://gitlab.com/biomedit/gpg-lite">gpg-lite</a>
                    and <a href="https://gitlab.com/biomedit/libbiomedit">libbiomedit</a> (shared code with
                    SETT)
                </li>
            </ul>
        </section>
        <section data-markdown>
            ### Outlook
            * Goal: <b>portal</b> will gain on importance and become the
            one-stop shop for data provider, researchers, and node managers.
            * Security quiz integration into portal.
            * <b>portal</b>: generate reports of transfers (per project or per time period).
            * <b>sett</b> CLI has been rewritten in <b>Rust</b> (using <a href="https://sequoia-pgp.org/">sequoia</a>).
            Remove dependence on <code>GnuPG</code> and its integration <code>gpg-lite</code>.
            * Replacement of SFTP by S3 (https) as primary data transfer protocol.
        </section>
        <section>
            <section>
                <h3>The End</h3>
                <a href="https://xkcd.com/2054/">
                    <img src="img/data_pipeline_2x.png"
                         title="&quot;Is the pipeline literally running from your laptop?&quot; &quot;Don't be silly, my laptop disconnects far too often to host a service we rely on. It's running on my phone.&quot;"/>
                </a>
                <p>
                    <small><a href="https://xkcd.com">xkcd.com</a></small>
                </p>
            </section>
            <section>
                <h3>Links</h3>
                <p>
                    Open Source BioMedIT projects:
                    <a href="https://gitlab.com/biomedit">gitlab.com/biomedit</a>
                </p>
                <p>
                    BioMedIT organization:
                    <a href="https://biomedit.ch/">BioMedIT</a>
                </p>
            </section>
        </section>
    </div>
</div>

<script src="dist/reveal.js"></script>
<script src="plugin/notes/notes.js"></script>
<script src="plugin/markdown/markdown.js"></script>
<script src="plugin/highlight/highlight.js"></script>
<script>
    // More info about initialization & config:
    // - https://revealjs.com/initialization/
    // - https://revealjs.com/config/
    Reveal.initialize({
        hash: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [RevealMarkdown, RevealHighlight, RevealNotes]
    });
</script>
</body>
</html>
